# Contributing

## Adding a feature

1. Open an issue and explain what you're planning to do. It is better to discuss new idea first,
   rather when diving into code.
2. Add some tests.
3. Write the code.
4. Make sure all tests pass.
5. Commit with detailed explanation what you've done in a message.
6. Open pull request.

## Breaking/removing a feature

1. Add deprecation warning and fallback to old behaivour if possible.
2. Explain how to migrate to the new code in CHANGELOG.
3. Update/remove tests.
4. Update the code.
5. Make sure all tests pass.
6. Commit with detailed explanation what you've done in a message.
7. Open pull request.

## Fixing a bug

1. Add failing test.
2. Fix the bug.
3. Make sure all tests pass.
4. Commit with detailed explanation what you've done in a message.
5. Open pull request.

## Fixing a typo

1. Commit with a message that include "[ci skip]" remark.
2. Open pull request.

## Running the tests

```
# Runs the test suite against the latest version of Rails.
bundle exec rake test

# Runs the test suite for a specific version of Rails.
bundle exec rake test RAILS_VERSION=4.2

# Runs the test suite for all supported versions of Rails.
bundle exec rake test_all
```

## Working with documentation

```
yard server -dr
open http://localhost:8808
```
